Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestInput/FrmRequestInputAuxiliary.cs	(revision 51)
@@ -0,0 +1,2225 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using System.Collections;
+using System.Drawing;
+
+using ProcessManagement.Common;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.IOAccess;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmRequestInput : Form
+    {
+        #region 変数
+        /// <summary>
+        /// 増減工事表示行数
+        /// </summary>
+        private int m_ChildConstructionRowCount = 4;
+
+        /// <summary>
+        /// 請求明細表示列数
+        /// </summary>
+        private int m_RequestColumnCount = 3;
+
+        /// <summary>
+        /// DataGridViewRowオブジェクトハッシュテーブル
+        /// </summary>
+        private Hashtable m_HtRowObject = new Hashtable();
+
+        /// <summary>
+        /// 消費税率
+        /// </summary>
+        private double m_TaxRate = (CommonMotions.SystemMasterData.ConsumptionTax / 100);
+
+        /// <summary>
+        /// 工事基本情報
+        /// </summary>
+        private ConstructionBaseInfo m_ConstructionData = new ConstructionBaseInfo();
+
+        /// <summary>
+        /// 工事詳細台帳データ
+        /// </summary>
+        private ConstructionLedger m_ConstructionLedger = new ConstructionLedger();
+
+        /// <summary>
+        /// 工事基本明細情報
+        /// </summary>
+        private Dictionary<int,string> m_DicConstructionDetail = new Dictionary<int, string>();
+
+        /// <summary>
+        /// 請求情報
+        /// </summary>
+        private RequestData m_RequestData = new RequestData();
+
+        /// <summary>
+        /// 請求合計情報
+        /// </summary>
+        private List<RequestTotalData> m_LstRequestTotalData = new List<RequestTotalData>();
+
+        /// <summary>
+        /// 請求明細情報
+        /// </summary>
+        private Dictionary<int,Dictionary<int,RequestDataDetail>> m_DicRequestDataDetail = new Dictionary<int, Dictionary<int, RequestDataDetail>>();
+
+        /// <summary>
+        /// 入金明細情報
+        /// </summary>
+        private Dictionary<int,DepositDataDetail> m_DicDepositDataDetail = new Dictionary<int, DepositDataDetail>();
+
+        /// <summary>
+        /// 工事増減情報リスト
+        /// </summary>
+        private List<int> m_LstConstructionLink = new List<int>();
+
+        /// <summary>
+        /// 増減工事・基本情報
+        /// </summary>
+        private List<ConstructionBaseInfo> m_LstChldContructionData = new List<ConstructionBaseInfo>();
+
+        /// <summary>
+        /// 増減工事・明細情報
+        /// </summary>
+        private Dictionary<int,Dictionary<int,string>> m_DicChldConstructionDetail = new Dictionary<int,Dictionary<int, string>>();
+
+        /// <summary>
+        /// 増減工事・詳細台帳データ
+        /// </summary>
+        private Dictionary<int,ConstructionLedger> m_DicChldConstructionLedger = new Dictionary<int, ConstructionLedger>();
+
+        /// <summary>
+        /// 承認データ
+        /// </summary>
+        private Dictionary<int,List<ProcessApproval>> m_DicProcessApproval = new Dictionary<int, List<ProcessApproval>>();
+
+        /// <summary>
+        /// 承認経路データ
+        /// </summary>
+        private Dictionary<int,ApprovalMaster> m_DicApprovalMaster = new Dictionary<int, ApprovalMaster>();
+
+        /// <summary>
+        /// 請求合計レコード更新追加確認ディクショナリ
+        /// </summary>
+        private Dictionary<RequestTotalData, bool> m_DicReqTotalRec = new Dictionary<RequestTotalData, bool>();
+
+        /// <summary>
+        /// 請求明細レコード更新追加確認ディクショナリ
+        /// </summary>
+        private Dictionary<RequestDataDetail, bool> m_DicReqDetailRec = new Dictionary<RequestDataDetail, bool>();
+
+        /// <summary>
+        /// 案件進捗日付データ
+        /// </summary>
+        private Dictionary<int, ConstructionProgressDate> m_DicConstProgressDate = new Dictionary<int, ConstructionProgressDate>();
+        #endregion
+
+        /// <summary>
+        /// 請求データ未登録フラグ
+        /// </summary>
+        private bool isEmptyConstructionBaseInfo = false;
+
+        /// <summary>
+        /// 請求書申請チェックと確認メッセージボックスの表示
+        /// </summary>
+        /// <param name="orderNo"></param>
+        /// <returns></returns>
+        private bool checkApproval(int orderNo)
+        {
+            bool chkResult = true;
+
+            // 合計セクションの請求金額行を取得
+            var totalRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
+
+            // 工事金額と請求金額を取得
+            double constPrice = (double)totalRow.Cells[GetColumnIndexNum(ColumnIndex.ConstructionPrice)].Value;
+            double billPrice = (double)totalRow.Cells[GetColumnIndexNum(ColumnIndex.Total)].Value;
+
+            // 一括請求の場合
+            if ((m_ConstructionData.BillingSplitFlg == 0) && (orderNo == 1))
+            {
+                if (m_ConstructionData.ConstructionStatusFlg < 8)
+                {
+                    // 工事のステータスが施工完了未満の場合はエラー
+                    MessageBox.Show(this, s_MessageNotCompletionConstruction, s_RequestApprovalDialogTitle, MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    chkResult = false;
+                }
+                else if (constPrice > billPrice)
+                {
+                    // 請求金額合計が工事金額に満たないので、確認ダイアログを表示
+                    DialogResult res = MessageBox.Show(this, s_MessageNotCompletionRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
+                    chkResult = (res == DialogResult.Yes);
+                }
+            }
+            else if (constPrice < billPrice)
+            {
+                // 請求金額合計が工事金額を超えているので、確認ダイアログを表示
+                DialogResult res = MessageBox.Show(this, s_MessageOverRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
+                chkResult = (res == DialogResult.Yes);
+            }
+            else
+            {
+                // 承認データチェック
+                RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
+                if (m_DicProcessApproval.ContainsKey(orderNo))
+                {
+                    stat = CheckApprovalStatus(m_DicProcessApproval[orderNo], m_DicApprovalMaster);
+                }
+
+                if (stat == RequestApprovalStatus.NowInput)
+                {
+                    DialogResult res = MessageBox.Show(this, s_MessageComfirmRequest, s_RequestApprovalDialogTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
+                    chkResult = (res == DialogResult.Yes);
+                }
+
+            }
+
+            return chkResult;
+        }
+
+        /// <summary>
+        /// DataGridViewでのカラムインデックス番号を取得
+        /// </summary>
+        /// <param name="cEnum">カラム種別</param>
+        /// <param name="count">請求情報の回数。請求情報以外のカラム種別を指定する際は省略可</param>
+        /// <returns></returns>
+        private int GetColumnIndexNum(ColumnIndex cEnum, int count = 1)
+        {
+            int cIndex = -1;
+            try
+            {
+                if (cEnum < ColumnIndex.RequestInfo)
+                {
+                    cIndex = (int)cEnum;
+                }
+                else if (cEnum == ColumnIndex.RequestInfo)
+                {
+                    cIndex = (int)ColumnIndex.RequestInfo + count - 1;
+                }
+                else
+                {
+                    cIndex = (int)cEnum + m_RequestColumnCount - 1;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+            return cIndex;
+        }
+
+        /// <summary>
+        /// DataGridViewでの行インデックス番号を取得
+        /// </summary>
+        /// <param name="cEnum">カラム種別</param>
+        /// <param name="count">請求情報の回数。請求情報以外のカラム種別を指定する際は省略可</param>
+        /// <returns></returns>
+        private int GetRowIndexNum(RowSectionIndex section, RowKind kind, int childIndex = 0)
+        {
+            int rIndex = -1;
+            try
+            {
+                var row = GetDataGridViewRowObject(section, kind, childIndex);
+                rIndex = (row != null) ? row.Index : -1;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+            return rIndex;
+        }
+
+        /// <summary>
+        /// DataGridViewRowオブジェクトをハッシュテーブルより取得する
+        /// </summary>
+        /// <param name="sectIndex"></param>
+        /// <param name="kind"></param>
+        /// <param name="childIndex"></param>
+        /// <returns></returns>
+        private DataGridViewRow GetDataGridViewRowObject(RowSectionIndex sectIndex, RowKind kind, int childIndex = 0)
+        {
+            DataGridViewRow dataGridRow = null;
+
+            try
+            {
+                if (m_HtRowObject.ContainsKey(sectIndex))
+                {
+                    var lst = m_HtRowObject[sectIndex] as List<Hashtable>;
+
+                    if (childIndex < lst.Count)
+                    {
+                        var htInSection = lst[childIndex] as Hashtable;
+
+                        if (htInSection.ContainsKey(kind))
+                        {
+                            dataGridRow = (DataGridViewRow)htInSection[kind];
+                        }
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+            return dataGridRow;
+        }
+
+        /// <summary>
+        /// DataGridViewRowオブジェクトをハッシュテーブルに設定する
+        /// </summary>
+        /// <param name="gridRow"></param>
+        /// <param name="sectIndex"></param>
+        /// <param name="kind"></param>
+        /// <param name="childIndex"></param>
+        private void SetDataGridViewRowObject(DataGridViewRow gridRow, RowSectionIndex sectIndex, RowKind kind, int childIndex = 0)
+        {
+            try
+            {
+                List<Hashtable> lst;
+                if (!m_HtRowObject.ContainsKey(sectIndex))
+                {
+                    // ハッシュテーブルのリストを追加
+                    lst = new List<Hashtable>();
+                    m_HtRowObject.Add(sectIndex, lst);
+                }
+                else
+                {
+                    lst = m_HtRowObject[sectIndex] as List<Hashtable>;
+                }
+
+                Hashtable htInSection;
+                if (lst.Count <= childIndex)
+                {
+                    htInSection = new Hashtable();
+                    lst.Add(htInSection);
+                }
+                else
+                {
+                    htInSection = lst[childIndex] as Hashtable;
+                }
+
+                if (!htInSection.ContainsKey(kind))
+                {
+                    htInSection.Add(kind, gridRow);
+                }
+                else
+                {
+                    htInSection[kind] = gridRow;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// DataGridViewの初期表示設定
+        /// </summary>
+        private void SetGridDisplay()
+        {
+            try
+            {
+                // DataGrid全体のプロパティ設定
+                dgv1.EnableHeadersVisualStyles = false;
+                dgv1.AutoGenerateColumns = false;
+                dgv1.ColumnHeadersHeight = this.dgv1.ColumnHeadersHeight + 5;
+                dgv1.ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                dgv1.ColumnHeadersDefaultCellStyle.BackColor = Color.Aquamarine;
+                dgv1.AllowUserToAddRows = false;
+                dgv1.RowTemplate.Height = 22;
+                dgv1.Font = new System.Drawing.Font("ＭＳ 明朝", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+
+                // 列タイトル設定
+                foreach (ColumnIndex cIndex in s_HtColumnTitles.Keys)
+                {
+                    if (s_HtColumnTitles[cIndex].GetType() == typeof(string))
+                    {
+                        dgv1.Columns[GetColumnIndexNum(cIndex)].HeaderText = (string)s_HtColumnTitles[cIndex];
+                    }
+                    else if (s_HtColumnTitles[cIndex].GetType() == typeof(List<string>))
+                    {
+                        var lst = s_HtColumnTitles[cIndex] as List<string>;
+                        foreach (var strTitle in lst)
+                        {
+                            int colIndex = GetColumnIndexNum(cIndex, lst.IndexOf(strTitle) + 1);
+                            dgv1.Columns[colIndex].HeaderText = strTitle;
+                            dgv1.Columns[colIndex].HeaderCell.Style.ForeColor = Color.DarkGray;
+                        }
+                    }
+                }
+
+                // 行追加処理
+                int rIndex = 0;
+                foreach (RowSectionIndex sectionIndex in Enum.GetValues(typeof(RowSectionIndex)))
+                {
+                    // セクションごとの処理
+
+                    for (int sectLoop = 0; sectLoop < ((sectionIndex == RowSectionIndex.ChildConstruction) ? 4 : 1); sectLoop++)
+                    {
+                        // 増減工事セクションは4回繰り返す
+
+                        foreach (RowKind kindIndex in s_HtRowSections[sectionIndex])
+                        {
+                            // セクション内の行の追加
+                            dgv1.Rows.Add();
+                            dgv1.Rows[dgv1.RowCount - 1].Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value = sectionIndex;
+                            dgv1.Rows[dgv1.RowCount - 1].Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value = kindIndex;
+
+                            // ハッシュデータに行オブジェクトを追加
+                            SetDataGridViewRowObject(dgv1.Rows[rIndex], sectionIndex, kindIndex, sectLoop);
+
+                            // 固定表示ラベルの設定
+                            if (s_HtLabels.ContainsKey(sectionIndex) && s_HtLabels[sectionIndex].ContainsKey(kindIndex))
+                            {
+                                foreach (ColumnIndex cIndex in s_HtLabels[sectionIndex][kindIndex].Keys)
+                                {
+                                    int cNum = GetColumnIndexNum(cIndex);
+                                    dgv1.Rows[rIndex].Cells[cNum].Value = s_HtLabels[sectionIndex][kindIndex][cIndex];
+                                    dgv1.Rows[rIndex].Cells[cNum].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                                }
+                            }
+
+                            // 背景色の設定
+                            SetRowBackgroundColor(sectionIndex, dgv1.Rows[rIndex], sectLoop);
+
+                            if (sectionIndex == RowSectionIndex.ChildConstruction)
+                            {
+                                // 増減工事行は一旦文字色をDarkGrayに設定
+                                dgv1.Rows[rIndex].DefaultCellStyle.ForeColor = Color.DarkGray;
+
+                            }
+                            rIndex++;
+                        }
+                    }
+                }
+
+                dgv1.Rows[2].Frozen = true;
+
+                GetDisplayDatas();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 増減工事行の追加処理
+        /// </summary>
+        /// <param name="stbIndex"></param>
+        private void AddChildConstructionInfoRow(int stbIndex)
+        {
+            try
+            {
+                // 増減工事最終行のオブジェクトを取得
+                var lastChldConstRow = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, m_ChildConstructionRowCount - 1);
+
+                // 増減工事最終行の行番号を取得
+                int lastChldConstRowIndex = dgv1.Rows.IndexOf(lastChldConstRow);
+
+                // 行を追加
+                foreach (RowKind kindIndex in s_HtRowSections[RowSectionIndex.ChildConstruction])
+                {
+                    // 行オブジェクト作成
+                    var rowObject = new DataGridViewRow();
+
+                    // セクション内の行の挿入
+                    dgv1.Rows.Insert(++lastChldConstRowIndex, rowObject);
+
+                    dgv1.Rows[lastChldConstRowIndex].Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value = RowSectionIndex.ChildConstruction;
+                    dgv1.Rows[lastChldConstRowIndex].Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value = kindIndex;
+
+                    // 行の背景色を設定
+                    SetRowBackgroundColor(RowSectionIndex.ChildConstruction, dgv1.Rows[lastChldConstRowIndex], stbIndex);
+
+                    // ハッシュデータに行オブジェクトを追加
+                    SetDataGridViewRowObject(dgv1.Rows[lastChldConstRowIndex], RowSectionIndex.ChildConstruction, kindIndex, stbIndex);
+
+                    // 固定ラベルの表示
+                    if (s_HtLabels.ContainsKey(RowSectionIndex.ChildConstruction))
+                    {
+                        if (s_HtLabels[RowSectionIndex.ChildConstruction].ContainsKey(kindIndex))
+                        {
+                            foreach (var colIndex in s_HtLabels[RowSectionIndex.ChildConstruction][kindIndex].Keys)
+                            {
+                                int cIndex = GetColumnIndexNum(colIndex);
+                                dgv1.Rows[lastChldConstRowIndex].Cells[cIndex].Value = s_HtLabels[RowSectionIndex.ChildConstruction][kindIndex][colIndex];
+                            }
+                        }
+                    }
+
+                }
+
+                m_ChildConstructionRowCount++;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 行の背景色の設定
+        /// </summary>
+        /// <param name="sectionIndex"></param>
+        /// <param name="gridRow"></param>
+        /// <param name="sectLoop"></param>
+        private void SetRowBackgroundColor(RowSectionIndex sectionIndex, DataGridViewRow gridRow, int sectLoop = 0)
+        {
+            try
+            {
+                // 行の背景色の設定
+                if (s_HtRowColors.ContainsKey(sectionIndex))
+                {
+                    if (s_HtRowColors[sectionIndex].GetType() == typeof(Color))
+                    {
+                        // セクションごとの色を設定
+                        gridRow.DefaultCellStyle.BackColor = (Color)s_HtRowColors[sectionIndex];
+                    }
+                    else if (s_HtRowColors[sectionIndex].GetType() == typeof(List<Color>))
+                    {
+                        var lst = s_HtRowColors[sectionIndex] as List<Color>;
+                        gridRow.DefaultCellStyle.BackColor = lst[(sectLoop % lst.Count)];
+                    }
+                    else
+                    {
+                        gridRow.DefaultCellStyle.BackColor = Color.White;
+                    }
+
+                    if (gridRow.DefaultCellStyle.BackColor == Color.White)
+                    {
+                        gridRow.Cells[GetColumnIndexNum(ColumnIndex.Headline)].Style.BackColor = System.Drawing.SystemColors.Control;
+                        gridRow.Cells[GetColumnIndexNum(ColumnIndex.Label)].Style.BackColor = System.Drawing.SystemColors.Control;
+                    }
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// データベースよりデータを取得し、画面表示に反映する
+        /// </summary>
+        private void GetDisplayDatas()
+        {
+            try
+            {
+                // 工事基本情報取得
+                if (GetConstructionBaseInfo(m_ConstructionCode, ref m_ConstructionData))
+                {
+                    // 請求データ取得
+                    if (GetRequestData(ref m_RequestData))
+                    {
+                        // 請求合計データ取得
+                        if (GetRequestTotalDatas(m_RequestData.RequestNo, ref m_LstRequestTotalData))
+                        {
+                            // 請求明細データ取得
+                            GetRequestDataDetails(m_RequestData.RequestNo, ref m_DicRequestDataDetail);
+
+                            // 入金明細データ取得
+                            GetDepositDataDetail(m_RequestData.RequestNo, ref m_DicDepositDataDetail);
+
+                            // 承認データ取得
+                            GetProcessApproval(m_ConstructionCode, ref m_DicProcessApproval);
+                        }
+                    }
+                    else
+                    {
+                        isEmptyConstructionBaseInfo = true;
+                        // 工事番号から工事基本情報を取得
+                        m_RequestData.RequestNo = m_ConstructionCode;
+                        m_RequestData.ConstructionCode = m_ConstructionCode;
+                        if (!GetRequestDataFromConstructionBase(ref m_RequestData)) return;
+                    }
+
+                    // 工事基本情報明細取得
+                    GetConstructionBaseInfoDetail(m_ConstructionCode, ref m_DicConstructionDetail);
+
+                    // 工事詳細台帳データ取得
+                    GetConstructionLedger(m_ConstructionCode, ref m_ConstructionLedger);
+
+                    // 工事増減情報取得
+                    if (GetConstructionLink(ref m_LstConstructionLink))
+                    {
+                        // 増減工事の工事基本情報をすべて取得
+                        if (GetChildConstructionBaseInfo(m_LstConstructionLink, ref m_LstChldContructionData))
+                        {
+                            // 増減工事の工事明細情報をすべて取得
+                            GetChildConstructionBaseInfoDetail(m_LstConstructionLink, ref m_DicChldConstructionDetail);
+
+                            // 増減工事の工事詳細台帳データを取得
+                            GetChildConstructionLedger(m_LstConstructionLink, ref m_DicChldConstructionLedger);
+                        }
+                    }
+
+                    // 案件進捗日付データを取得
+                    GetConstructionProgressDate(m_ConstructionCode, ref m_DicConstProgressDate);
+
+                    // 承認経路マスタを取得
+                    GetApprovalMaster(m_ConstructionData.ConstructionPersonCode, ref m_DicApprovalMaster);
+
+                }
+
+                // 請求先名ラベル設定
+                if (m_DicConstructionDetail.ContainsKey((int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName))
+                {
+                    label1.Text = (string)m_DicConstructionDetail[(int)ConstructionBaseInfoDetail.DetailDataNo.OrderersName];
+                }
+                label1.TextAlign = ContentAlignment.MiddleLeft;
+
+                // 工事状態表示
+                SetConstructionStatus();
+
+                // 本工事行表示
+                SetOriginalConstructionInfo();
+
+                // 増減工事行表示
+                SetChildConstructionInfo();
+
+                // 請求明細列表示
+                foreach (var total in m_LstRequestTotalData)
+                {
+                    SetRequestInfoColumn(total.OrderNo - 1);
+                }
+
+                // 入金情報行表示
+                SetDepositInfo();
+
+                // 自動計算セル表示
+                SetAutoCalcRow();
+
+                // 合計行表示
+                SetTotalInfo();
+
+                // 入金情報行表示
+                SetDepositInfo();
+
+                // データが存在しない場合
+                if (m_LstRequestTotalData.Count == 0)
+                {
+                    // 1回目を追加
+                    AddRequest();
+                }
+
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// 工事状態表示設定
+        /// </summary>
+        private void SetConstructionStatus()
+        {
+            // 状態フラグが10(請求完了)が存在すれば
+            if (m_DicConstProgressDate.ContainsKey(10))
+            {
+                lblStatus.Text = "請求完了";
+                lblStatus.BackColor = Color.Blue;
+                lblStatus.ForeColor = Color.White;
+            }
+            // 状態フラグが9(請求準備)が存在すれば
+            else if(m_DicConstProgressDate.ContainsKey(9))
+            {
+                lblStatus.Text = "請求準備";
+                lblStatus.BackColor = Color.GreenYellow;
+                lblStatus.ForeColor = Color.Black;
+            }
+            // その他
+            else
+            {
+                lblStatus.Text = "";
+                lblStatus.BackColor = Color.Black;
+                lblStatus.ForeColor = Color.White;
+            }
+
+        }
+
+        /// <summary>
+        /// 本工事行表示設定
+        /// </summary>
+        /// <param name="m_HtConstructionDetail"></param>
+        /// <param name="m_ConstructionLedger"></param>
+        private void SetOriginalConstructionInfo()
+        {
+            try
+            {
+                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice);
+                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice);
+                var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
+
+                // 工事金額の消費税額を計算
+                double constructionTaxPrice = Math.Truncate(m_ConstructionLedger.OrdersDecisionPrice * m_TaxRate);
+
+                int cIndex;
+
+                // 工事番号
+                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionCode);
+                gridRowBillPrice.Cells[cIndex].Value = m_ConstructionCode;
+                gridRowTaxPrice.Cells[cIndex].Value = m_ConstructionCode;
+                gridRowAmount.Cells[cIndex].Value = m_ConstructionCode;
+
+                // 工事名
+                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionName);
+                gridRowBillPrice.Cells[cIndex].Value = m_DicConstructionDetail[(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName];
+
+                // 工事金額
+                cIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], m_ConstructionLedger.OrdersDecisionPrice);
+                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], constructionTaxPrice);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// 入金情報行表示設定
+        /// </summary>
+        /// <param name="m_HtRequestDataDetail"></param>
+        /// <param name="m_HtDepositDataDetail"></param>
+        private void SetDepositInfo ()
+        {
+            try
+            {
+                var gridPrice = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositPrice);
+                var gridDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
+
+                int cIndex;
+                double totalDeposit = 0;
+                double totalDiff = 0;
+
+                // 合計値を計算
+                foreach (var detail in m_LstRequestTotalData)
+                {
+                    if (m_DicDepositDataDetail.ContainsKey(detail.OrderNo))
+                    {
+                        var depDetail = m_DicDepositDataDetail[detail.OrderNo];
+                        totalDeposit += depDetail.DepositAmount;
+                        totalDiff += depDetail.CarryAmount;
+                    }
+                }
+
+                // 工事金額総計を計算
+                double totalOrderDecisionPrice = m_ConstructionLedger.OrdersDecisionPrice;
+                foreach (int constCode in m_LstConstructionLink)
+                {
+                    totalOrderDecisionPrice += m_DicChldConstructionLedger[constCode].OrdersDecisionPrice;
+                }
+
+                // 合計列
+                cIndex = GetColumnIndexNum(ColumnIndex.Total);
+                SetDataGridCellDecimal(gridPrice.Cells[cIndex], totalDeposit);
+                SetDataGridCellDecimal(gridDiff.Cells[cIndex], totalDiff);
+
+                // 残り列
+                cIndex = GetColumnIndexNum(ColumnIndex.Amount);
+                double amountDeposit = totalOrderDecisionPrice * (m_TaxRate + 1) - totalDeposit + totalDiff;
+                SetDataGridCellDecimal(gridPrice.Cells[cIndex], amountDeposit);
+                SetDataGridCellDecimal(gridDiff.Cells[cIndex], -totalDiff);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 増減工事行表示設定
+        /// </summary>
+        /// <param name="m_LstChldContructionData"></param>
+        /// <param name="m_HtChldConstructionDetail"></param>
+        private void SetChildConstructionInfo()
+        {
+            try
+            {
+                int cIndex;
+
+                // 増減工事の数分繰り返し
+                foreach (var info in m_LstChldContructionData)
+                {
+                    int rowIndex = m_LstChldContructionData.IndexOf(info);
+
+                    if (m_ChildConstructionRowCount <= rowIndex)
+                    {
+                        // 増減工事行が足りない場合は行を追加
+                        AddChildConstructionInfoRow(rowIndex);
+                    }
+
+                    var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, rowIndex);
+                    var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, rowIndex);
+
+                    // 各行の文字色を設定
+                    gridRowBillPrice.DefaultCellStyle.ForeColor = Color.Black;
+                    gridRowTaxPrice.DefaultCellStyle.ForeColor = Color.Black;
+
+                    // 工事番号
+                    cIndex = GetColumnIndexNum(ColumnIndex.ConstructionCode);
+                    gridRowBillPrice.Cells[cIndex].Value = info.ConstructionCode;
+                    gridRowTaxPrice.Cells[cIndex].Value = info.ConstructionCode;
+
+                    if (m_DicChldConstructionDetail.ContainsKey(info.ConstructionCode))
+                    {
+                        var detail = m_DicChldConstructionDetail[info.ConstructionCode] as Dictionary<int,string>;
+
+                        // 工事名
+                        if (detail.ContainsKey((int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName))
+                        {
+                            cIndex = GetColumnIndexNum(ColumnIndex.ConstructionName);
+                            gridRowBillPrice.Cells[cIndex].Value = detail[(int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName] as string;
+                        }
+
+                    }
+
+                    // 工事金額
+                    cIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+                    double ordersDecisionPrice = 0;
+                    double taxPrice = 0;
+                    if (m_DicChldConstructionLedger.ContainsKey(info.ConstructionCode))
+                    {
+                        var ledger = m_DicChldConstructionLedger[info.ConstructionCode] as ConstructionLedger;
+                        ordersDecisionPrice = ledger.OrdersDecisionPrice;
+                        taxPrice = Math.Truncate(ledger.OrdersDecisionPrice * m_TaxRate);
+                    }
+                    SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], ordersDecisionPrice);
+                    SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], taxPrice);
+
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 本工事セクションおよび増減工事セクションの、すべての自動計算カラムを計算する
+        /// </summary>
+        private void SetAutoCalcRow()
+        {
+            try
+            {
+                // 本工事セクション
+                if (m_DicRequestDataDetail.ContainsKey(m_ConstructionCode))
+                {
+                    foreach (RowKind kind in s_HtRowSections[RowSectionIndex.OriginalConstruction])
+                    {
+                        var gridRow = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, kind);
+                        SetAutoCalcCell(gridRow);
+
+                    }
+                }
+
+                // 増減工事セクション
+                foreach (int constCode in m_LstConstructionLink)
+                {
+                    foreach (RowKind kind in s_HtRowSections[RowSectionIndex.ChildConstruction])
+                    {
+                        var gridRow = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, kind, m_LstConstructionLink.IndexOf(constCode));
+                        SetAutoCalcCell(gridRow);
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 指定行の自動計算カラムを計算する
+        /// </summary>
+        /// <param name="row"></param>
+        private void SetAutoCalcCell(DataGridViewRow row)
+        {
+            try
+            {
+                var sectionIndex = (RowSectionIndex)row.Cells[GetColumnIndexNum(ColumnIndex.SectionIndex)].Value;
+                var rowKind = (RowKind)row.Cells[GetColumnIndexNum(ColumnIndex.RowKind)].Value;
+                var constCode = (int)row.Cells[GetColumnIndexNum(ColumnIndex.ConstructionCode)].Value;
+
+                if (m_DicRequestDataDetail.ContainsKey(constCode))
+                {
+                    double total = 0;
+                    foreach (var orderNo in m_DicRequestDataDetail[constCode].Keys)
+                    {
+                        int colIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, orderNo);
+                        switch (rowKind)
+                        {
+                            case RowKind.BillPrice:
+                                m_DicRequestDataDetail[constCode][orderNo].BillPrice = Convert.ToInt32(row.Cells[colIndex].Value);
+                                total += m_DicRequestDataDetail[constCode][orderNo].BillPrice;
+                                break;
+                            case RowKind.TaxPrice:
+                                m_DicRequestDataDetail[constCode][orderNo].TaxPrice = Convert.ToInt32(row.Cells[colIndex].Value);
+                                total += m_DicRequestDataDetail[constCode][orderNo].TaxPrice;
+                                break;
+                            case RowKind.AmountPrice:
+                                m_DicRequestDataDetail[constCode][orderNo].AmountBlance = Convert.ToInt32(row.Cells[colIndex].Value);
+                                total += m_DicRequestDataDetail[constCode][orderNo].AmountBlance;
+                                break;
+                            default:
+                                break;
+                        }
+                    }
+
+                    // 合計列
+                    int totalColIndex = GetColumnIndexNum(ColumnIndex.Total);
+                    SetDataGridCellDecimal(row.Cells[totalColIndex], total);
+
+                    // 残り列
+                    int amountColIndex = GetColumnIndexNum(ColumnIndex.Amount);
+                    if (rowKind != RowKind.AmountPrice)
+                    {
+                        // 未入金分以外
+                        // 工事金額を取得
+                        int constPriceColIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+                        double constPrice = Convert.ToDouble(row.Cells[constPriceColIndex].Value ?? 0);
+
+                        // 残り列に残り金額をセット
+                        SetDataGridCellDecimal(row.Cells[amountColIndex], constPrice - total);
+                    }
+                    else
+                    {
+                        var gridRowDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
+                        double diffPrice = Convert.ToDouble(gridRowDiff.Cells[totalColIndex].Value ?? 0);
+
+                        // 残り列に未入金残り金額をセット
+                        SetDataGridCellDecimal(row.Cells[amountColIndex], diffPrice - total);
+
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 合計セクション表示設定
+        /// </summary>
+        private void SetTotalInfo()
+        {
+            try
+            {
+                // 工事金額列
+                SetTotalInfoColumn(ColumnIndex.ConstructionPrice);
+
+                // 請求回数分繰り返し
+                foreach (var record in m_LstRequestTotalData)
+                {
+                    // 請求明細列
+                    SetTotalInfoColumn(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(record) + 1);
+                }
+
+                SetTotalSectionInfo();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 合計セクションの合計および残り列表示設定
+        /// </summary>
+        private void SetTotalSectionInfo()
+        {
+            try
+            {
+                double totalBillPrice = 0;
+                double totalNonTaxedPrice = 0;
+                double totalTaxPrice = 0;
+                double totalAmount = 0;
+
+                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
+                var gridRowNonTaxedPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
+                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
+                var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
+
+                int cIndex;
+
+                // 請求回数分繰り返し
+                foreach (var record in m_LstRequestTotalData)
+                {
+                    // 合計計算
+                    cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(record) + 1);
+                    totalBillPrice += Convert.ToDouble(gridRowBillPrice.Cells[cIndex].Value);
+                    totalNonTaxedPrice += Convert.ToDouble(gridRowNonTaxedPrice.Cells[cIndex].Value);
+                    totalTaxPrice += Convert.ToDouble(gridRowTaxPrice.Cells[cIndex].Value);
+                    totalAmount += Convert.ToDouble(gridRowAmount.Cells[cIndex].Value);
+                }
+
+                // 合計列
+                cIndex = GetColumnIndexNum(ColumnIndex.Total);
+                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], totalBillPrice);
+                SetDataGridCellDecimal(gridRowNonTaxedPrice.Cells[cIndex], totalNonTaxedPrice);
+                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], totalTaxPrice);
+                SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], totalAmount);
+
+                // 残り列
+                int constPriceIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+                cIndex = GetColumnIndexNum(ColumnIndex.Amount);
+                SetDataGridCellDecimal(gridRowNonTaxedPrice.Cells[cIndex], Convert.ToDouble(gridRowNonTaxedPrice.Cells[constPriceIndex].Value) - totalNonTaxedPrice);
+                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], Convert.ToDouble(gridRowTaxPrice.Cells[constPriceIndex].Value) - totalTaxPrice);
+
+                double amountBalance = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value);
+                SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], amountBalance);
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 合計行列表示設定
+        /// </summary>
+        /// <param name="colIndex"></param>
+        /// <param name="count"></param>
+        private void SetTotalInfoColumn(ColumnIndex colIndex, int count = 1)
+        {
+            // カラムインデックス取得
+            int cIndex = GetColumnIndexNum(colIndex, count);
+
+            SetTotalInfoColumn(cIndex);
+        }
+
+        /// <summary>
+        /// 合計行列表示設定
+        /// </summary>
+        /// <param name="cIndex"></param>
+        private void SetTotalInfoColumn(int cIndex)
+        { 
+            try
+            {
+                // DataGridViewRowのオブジェクトを取得
+                var gridRowBillPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
+                var gridRowNonTaxed = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
+                var gridRowTaxPrice = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
+
+                // 税抜き価格と消費税額を計算
+                double nonTaxedPrice = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice).Cells[cIndex].Value);
+                double taxPrice = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice).Cells[cIndex].Value);
+                for (int childRow = 0; childRow < m_ChildConstructionRowCount; childRow++)
+                {
+                    nonTaxedPrice += Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, childRow).Cells[cIndex].Value ?? 0.0);
+                    taxPrice += Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, childRow).Cells[cIndex].Value ?? 0.0);
+                }
+
+                // 行に表示設定
+                SetDataGridCellDecimal(gridRowNonTaxed.Cells[cIndex], nonTaxedPrice);
+                SetDataGridCellDecimal(gridRowTaxPrice.Cells[cIndex], taxPrice);
+                SetDataGridCellDecimal(gridRowBillPrice.Cells[cIndex], nonTaxedPrice + taxPrice);
+
+                // 処理中の列が工事金額列以外であれば以下の処理
+                if (GetColumnIndexNum(ColumnIndex.ConstructionPrice) != cIndex)
+                {
+                    // 未入金分
+                    var gridRowAmount = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
+
+                    SetDataGridCellDecimal(gridRowAmount.Cells[cIndex], Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value ?? 0.0));
+                    gridRowAmount.Cells[cIndex].Value = Convert.ToDouble(GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice).Cells[cIndex].Value ?? 0.0);
+
+                    // ヘッダセクションの請求書金額
+                    var gridRowBillTotalPrice = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.RequestSheetPrice);
+                    SetDataGridCellDecimal(gridRowBillTotalPrice.Cells[cIndex], nonTaxedPrice + taxPrice);
+
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        
+        /// <summary>
+        /// 承認状態を確認する
+        /// </summary>
+        /// <param name="lstProcApproval"></param>
+        /// <param name="dicApprovalMaster"></param>
+        /// <returns></returns>
+        private RequestApprovalStatus CheckApprovalStatus(List<ProcessApproval> lstProcApproval, Dictionary<int,ApprovalMaster> dicApprovalMaster)
+        {
+            // 「入力中」で初期化する
+            RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
+
+            try
+            {
+                // 承認データをすべて参照する
+                foreach (var procApproval in lstProcApproval)
+                {
+
+                    if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Approval)
+                         && dicApprovalMaster.ContainsKey(procApproval.PersonCode)
+                         && dicApprovalMaster[procApproval.PersonCode].ApprovalAuthority == 1)
+                    {
+                        // 承認ステータスが「承認」で承認者が最終決裁者の場合、「承認済み」とし、ループを離脱する
+                        stat = RequestApprovalStatus.Approval;
+                        break;
+                    }
+                    else if (procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.NotApproval)
+                    {
+                        // 不承認
+                        stat = RequestApprovalStatus.NotApproval;
+                    }
+                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Pending)
+                        && (stat > RequestApprovalStatus.Pending))
+                    {
+                        // 保留
+                        stat = RequestApprovalStatus.Pending;
+                    }
+                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Approval)
+                        && (stat > RequestApprovalStatus.NowApproval))
+                    {
+                        // 承認中
+                        stat = RequestApprovalStatus.NowApproval;
+                    }
+                    else if ((procApproval.ApprovalStatus == (int)CommonDefine.ApprovalStatus.Petition)
+                        && (stat > RequestApprovalStatus.Petition))
+                    {
+                        // 申請中
+                        stat = RequestApprovalStatus.Petition;
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            return stat;
+        }
+
+        /// <summary>
+        /// 請求明細列を表示設定
+        /// </summary>
+        /// <param name="reqIndex"></param>
+        private void SetRequestInfoColumn(int reqIndex)
+        {
+            try
+            {
+                int cIndex;
+                int orderNo = m_LstRequestTotalData[reqIndex].OrderNo;
+
+                // 列が足りない場合は追加する
+                if (reqIndex + 1 > m_RequestColumnCount)
+                {
+                    cIndex = GetColumnIndexNum(ColumnIndex.Amount);
+                    DataGridViewColumn colObj = new DataGridViewTextBoxColumn();
+                    colObj.ReadOnly = true;
+                    colObj.Width = 120;
+                    dgv1.Columns.Insert(cIndex, colObj);
+                    m_RequestColumnCount++;
+                    dgv1.Columns[cIndex].HeaderText = string.Format("{0}回目", reqIndex + 1);
+                }
+                else
+                {
+                    cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, reqIndex + 1);
+                }
+                dgv1.Columns[cIndex].HeaderCell.Style.ForeColor = Color.Black;
+
+                var requestTotalData = m_LstRequestTotalData[reqIndex];
+
+                // 請求書作成日
+                if (requestTotalData.BillCreationDate != DateTime.MinValue)
+                {
+                    var gridRowRequestCreateDate = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.RequestSheetCreateDate);
+                    gridRowRequestCreateDate.Cells[cIndex].Value = requestTotalData.BillCreationDate.ToShortDateString();
+                    gridRowRequestCreateDate.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                }
+
+                // 承認状態
+                var gridRowApprovalStatus = GetDataGridViewRowObject(RowSectionIndex.Header, RowKind.ApprobalStatus);
+                RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
+                if (m_DicProcessApproval.ContainsKey(orderNo))
+                {
+                    stat = CheckApprovalStatus(m_DicProcessApproval[orderNo], m_DicApprovalMaster);
+                }
+                gridRowApprovalStatus.Cells[cIndex].Value = s_DictApprovalStatusString[stat];
+                gridRowApprovalStatus.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+
+                // 本工事行
+                if (m_DicRequestDataDetail.ContainsKey(m_ConstructionCode))        // 本工事分の明細があることを確認
+                {
+                    RequestDataDetail detail;
+                    if (m_DicRequestDataDetail[m_ConstructionCode].ContainsKey(orderNo))
+                    {
+                        detail = m_DicRequestDataDetail[m_ConstructionCode][orderNo];
+                    }
+                    else
+                    {
+                        detail = m_DicRequestDataDetail[m_ConstructionCode][orderNo] = new RequestDataDetail();
+                        detail.RequestNo = m_RequestData.RequestNo;
+                        detail.ConstructionCode = m_ConstructionCode;
+                        detail.OrderNo = orderNo;
+                        detail.ConstructionKind = 0;
+                    }
+
+                    // 請求金額
+                    var gridRowOrgBillPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.BillPrice);
+                    SetDataGridCellDecimal(gridRowOrgBillPrice.Cells[cIndex], (double)detail.BillPrice);
+                    gridRowOrgBillPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+
+                    // 消費税
+                    var gridRowOrgTaxPrice = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.TaxPrice);
+                    SetDataGridCellDecimal(gridRowOrgTaxPrice.Cells[cIndex], (double)detail.TaxPrice);
+                    gridRowOrgTaxPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+
+                    // 未入金分
+                    var gridRowOrgAmount = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
+                    SetDataGridCellDecimal(gridRowOrgAmount.Cells[cIndex], (double)detail.AmountBlance);
+                    gridRowOrgAmount.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+
+                }
+
+                // 増減工事行
+                foreach (int constCode in m_LstConstructionLink)
+                {
+                    Dictionary<int, RequestDataDetail> dicRequestDataDetail;
+                    if (m_DicRequestDataDetail.ContainsKey(constCode))
+                    {
+                        dicRequestDataDetail = m_DicRequestDataDetail[constCode];
+                    }
+                    else
+                    {
+                        dicRequestDataDetail = m_DicRequestDataDetail[constCode] = new Dictionary<int, RequestDataDetail>();
+                    }
+
+                    RequestDataDetail detail;
+                    if (dicRequestDataDetail.ContainsKey(orderNo))
+                    {
+                        detail = dicRequestDataDetail[orderNo];
+                    }
+                    else
+                    {
+                        detail = dicRequestDataDetail[orderNo] = new RequestDataDetail();
+                        detail.RequestNo = m_RequestData.RequestNo;
+                        detail.ConstructionCode = constCode;
+                        detail.OrderNo = orderNo;
+                        detail.ConstructionKind = 1;
+                    }
+
+                    // 請求金額
+                    var gridRowChldBillPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.BillPrice, m_LstConstructionLink.IndexOf(constCode));
+                    SetDataGridCellDecimal(gridRowChldBillPrice.Cells[cIndex], (double)detail.BillPrice);
+                    gridRowChldBillPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+
+                    // 消費税
+                    var gridRowChldTaxPrice = GetDataGridViewRowObject(RowSectionIndex.ChildConstruction, RowKind.TaxPrice, m_LstConstructionLink.IndexOf(constCode));
+                    SetDataGridCellDecimal(gridRowChldTaxPrice.Cells[cIndex], (double)detail.TaxPrice);
+                    gridRowChldTaxPrice.Cells[cIndex].ReadOnly = (stat == RequestApprovalStatus.Approval) ? true : false;
+
+                }
+
+                // OrderNoで入金明細があるかを確認
+                var depositDetail = m_DicDepositDataDetail.ContainsKey(orderNo) ? m_DicDepositDataDetail[orderNo] : new DepositDataDetail();
+
+                if (m_DicDepositDataDetail.ContainsKey(orderNo))
+                {
+                    // あったら入金データを取得
+                    var depositData = new DepositData();
+                    if (GetDepositData(depositDetail.OrderersDivision,
+                                        depositDetail.OrderersCode,
+                                        depositDetail.TargetDate,
+                                        depositDetail.SeqNo,
+                                        ref depositData))
+                    {
+                        // 取得できたら表示設定
+
+                        // 入金日
+                        var gridRowDepositDate = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositDate);
+                        gridRowDepositDate.Cells[cIndex].Value = depositData.DepositDate.ToShortDateString();
+
+                    }
+
+                    // 入金金額
+                    var gridRowDepositPrice = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositPrice);
+                    SetDataGridCellDecimal(gridRowDepositPrice.Cells[cIndex], (double)depositDetail.DepositAmount);
+
+                    // 差額
+                    var gridRowDepositDiff = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DifferencePrice);
+                    SetDataGridCellDecimal(gridRowDepositDiff.Cells[cIndex], (double)depositDetail.CarryAmount);
+
+                    // 入金確認
+                    var gridRowDepositCheck = GetDataGridViewRowObject(RowSectionIndex.DepositInfo, RowKind.DepositCheck);
+                    gridRowDepositCheck.Cells[cIndex].Value = depositDetail.ApprovalEndFlg ? "確認済" : "";
+                    gridRowDepositCheck.Cells[cIndex].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// DataGridViewCellに数値を表示設定する
+        /// </summary>
+        /// <param name="cell"></param>
+        /// <param name="value"></param>
+        private void SetDataGridCellDecimal(DataGridViewCell cell, double value)
+        {
+            try
+            {
+                if (cell != null)
+                {
+                    cell.Value = value;
+                    cell.Style.Format = "#,0";
+                    cell.Style.ForeColor = (value < 0) ? Color.Red : Color.Black;
+                    cell.Style.Alignment = DataGridViewContentAlignment.MiddleRight;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// 請求回数追加
+        /// </summary>
+        private void AddRequest()
+        {
+            try
+            {
+                // 請求合計データを追加
+                var totalData = new RequestTotalData();
+                totalData.RequestNo = m_RequestData.RequestNo;
+                totalData.OrderNo = m_LstRequestTotalData.Count + 1;
+                totalData.OrderersDivision = m_RequestData.OrderersDivision;
+                totalData.OrderersCode = m_RequestData.OrderersCode;
+                totalData.BillCreationDate = DateTime.MinValue;
+
+                m_LstRequestTotalData.Add(totalData);
+
+                // 請求明細データの追加の対象となる工事番号を収集
+                List<int> lstConstCodes = new List<int>();
+                lstConstCodes.Add(m_ConstructionCode);
+                lstConstCodes.AddRange(m_LstConstructionLink);
+
+                // 請求明細データを追加
+                foreach (int code in lstConstCodes)
+                {
+                    if (!m_DicRequestDataDetail.ContainsKey(code))
+                    {
+                        m_DicRequestDataDetail[code] = new Dictionary<int, RequestDataDetail>();
+                    }
+
+                    var detail = new RequestDataDetail();
+                    detail.RequestNo = m_RequestData.RequestNo;
+                    detail.OrderNo = totalData.OrderNo;
+                    detail.ConstructionCode = code;
+                    detail.ConstructionKind = (code == m_ConstructionCode) ? 0 : 1;
+
+                    m_DicRequestDataDetail[code][detail.OrderNo] = detail;
+                }
+
+                // 追加した請求明細列表示
+                SetRequestInfoColumn(totalData.OrderNo - 1);
+
+                // 自動計算セル表示
+                SetAutoCalcRow();
+
+                // 合計セクション表示
+                SetTotalInfoColumn(ColumnIndex.RequestInfo, m_LstRequestTotalData.Count());
+
+                // 合計セクション合計列および残り列表示
+                SetTotalSectionInfo();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 登録処理
+        /// </summary>
+        private bool AcceptData()
+        {
+            bool ret;
+
+            var reqDB = new IORequestData();
+            var reqTotalDB = new IORequestTotalData();
+            var reqDetailDB = new IORequestDataDetail();
+
+            ret = true;
+
+            try
+            {
+                // ---------- 行インデックス ----------------
+                // 工事金額列インデックス
+                int constPriceColIndex = GetColumnIndexNum(ColumnIndex.ConstructionPrice);
+
+                // 合計列インデックス
+                int totalColIndex = GetColumnIndexNum(ColumnIndex.Total);
+
+                // 残り列インデックス
+                int amountColIndex = GetColumnIndexNum(ColumnIndex.Amount);
+
+
+                // ---------- 行オブジェクト ----------------
+                var billPriceRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.BillPrice);
+                var nonTaxedRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.NonTaxedPrice);
+                var taxPriceRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.TaxPrice);
+                var amountRow = GetDataGridViewRowObject(RowSectionIndex.Total, RowKind.AmountPrice);
+                var orgAmountRow = GetDataGridViewRowObject(RowSectionIndex.OriginalConstruction, RowKind.AmountPrice);
+
+                // 更新用データ収集処理
+                m_RequestData.AmountPaid = 0;
+                m_RequestData.PricePaid = 0;
+                m_RequestData.TaxPricePaid = 0;
+                m_RequestData.AmountBlance = 0;
+                int totalAmountPaid = 0;
+                int totalPricePaid = 0;
+                int totalTaxPaid = 0;
+
+                foreach (var totalData in m_LstRequestTotalData)
+                {
+                    int cIndex = GetColumnIndexNum(ColumnIndex.RequestInfo, m_LstRequestTotalData.IndexOf(totalData) + 1);
+
+                    // 承認データチェック
+                    RequestApprovalStatus stat = RequestApprovalStatus.NowInput;
+                    if (m_DicProcessApproval.ContainsKey(totalData.OrderNo))
+                    {
+                        stat = CheckApprovalStatus(m_DicProcessApproval[totalData.OrderNo], m_DicApprovalMaster);
+                    }
+
+                    if (stat < RequestApprovalStatus.NowInput)
+                    {
+                        // 請求済金額
+                        m_RequestData.AmountPaid += Convert.ToInt32(billPriceRow.Cells[cIndex].Value);
+
+                        // 請求済工事金額
+                        m_RequestData.PricePaid += Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value);
+
+                        // 請求済消費税金額
+                        m_RequestData.TaxPricePaid += Convert.ToInt32(taxPriceRow.Cells[cIndex].Value);
+
+                        // 未入金額
+                        m_RequestData.AmountBlance -= Convert.ToInt32(orgAmountRow.Cells[cIndex].Value);
+                    }
+
+                    // 請求合計データ
+                    totalData.BillTotalPrice = Convert.ToInt32(billPriceRow.Cells[cIndex].Value);
+                    totalData.BillPrice = Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value);
+                    totalData.TaxPrice = Convert.ToInt32(taxPriceRow.Cells[cIndex].Value);
+                    totalData.AmountBlance = Convert.ToInt32(amountRow.Cells[cIndex].Value);
+                    totalData.AmountPaid = (totalAmountPaid += Convert.ToInt32(billPriceRow.Cells[cIndex].Value));
+                    totalData.PricePaid = (totalPricePaid += Convert.ToInt32(nonTaxedRow.Cells[cIndex].Value));
+                    totalData.TaxPricePaid = (totalTaxPaid += Convert.ToInt32(taxPriceRow.Cells[cIndex].Value));
+                    totalData.PriceBalance = Convert.ToInt32(nonTaxedRow.Cells[constPriceColIndex].Value) - totalPricePaid;
+                    totalData.TaxBalance = Convert.ToInt32(taxPriceRow.Cells[constPriceColIndex].Value) - totalTaxPaid;
+
+                    // 請求合計データテーブル更新および追加処理
+                    if (m_DicReqTotalRec.ContainsKey(totalData))
+                    {
+                        // データ読み込み時に存在したレコードなら更新
+                        reqTotalDB.UpdateAction("", totalData);
+                    }
+                    else
+                    {
+                        // データ読み込み時に存在しなかったレコードなら追加
+                        reqTotalDB.InsertAction(totalData);
+                        m_DicReqTotalRec[totalData] = true;
+                    }
+
+                    foreach (var constCode in m_DicRequestDataDetail.Keys)
+                    {
+                        if (m_DicReqDetailRec.ContainsKey(m_DicRequestDataDetail[constCode][totalData.OrderNo]))
+                        {
+                            // データ読み込み時に存在したレコードなら更新
+                            reqDetailDB.UpdateAction("", m_DicRequestDataDetail[constCode][totalData.OrderNo]);
+                        }
+                        else
+                        {
+                            // データ読み込み時に存在しなかったレコードなら追加
+                            reqDetailDB.InsertAction(m_DicRequestDataDetail[constCode][totalData.OrderNo]);
+                            m_DicReqDetailRec[m_DicRequestDataDetail[constCode][totalData.OrderNo]] = true;
+                        }
+                    }
+
+                }
+
+                // 請求残工事金額
+                m_RequestData.PriceBalance = Convert.ToInt32(nonTaxedRow.Cells[constPriceColIndex].Value) - m_RequestData.PricePaid;
+
+                // 請求残消費税金額
+                m_RequestData.TaxBalance = Convert.ToInt32(taxPriceRow.Cells[constPriceColIndex].Value) - m_RequestData.TaxPricePaid;
+
+                // 未入金額
+                m_RequestData.AmountBlance += Convert.ToInt32(orgAmountRow.Cells[amountColIndex].Value) + Convert.ToInt32(orgAmountRow.Cells[totalColIndex].Value);
+
+                // 請求データが登録されていない場合はレコード作成
+                if (isEmptyConstructionBaseInfo)
+                {
+                    // 請求データ追加処理
+                    reqDB.InsertAction(m_RequestData);
+                } else
+                {
+                    // 請求データ更新処理
+                    reqDB.UpdateAction("", m_RequestData);
+                }
+
+                reqDB.commit();
+                reqTotalDB.commit();
+                reqDetailDB.commit();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+
+                ret = false;
+            }
+            finally
+            {
+                reqDB.close();
+                reqTotalDB.close();
+                reqDetailDB.close();
+                reqDB = null;
+                reqTotalDB = null;
+                reqDetailDB = null;
+            }
+
+            return ret;
+
+        }
+        #region データベースアクセスメソッド
+
+        #region 工事基本情報
+        /// <summary>
+        /// 工事基本情報を工事基本情報テーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="data"></param>
+        /// <returns>true：成功 false：失敗</returns>
+        private bool GetConstructionBaseInfo(int constructionCode, ref ConstructionBaseInfo data)
+        {
+            var sbDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事基本情報取得クラス領域
+                var wrk = new ConstructionBaseInfo();
+
+                // 工事基本情報取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事基本情報取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 増減工事用工事基本情報
+        /// <summary>
+        /// 増減工事分のすべての工事基本情報を取得する
+        /// </summary>
+        /// <param name="constructionCode">本工事番号</param>
+        /// <param name="data"></param>
+        /// <returns>true：成功 false：失敗</returns>
+        private bool GetChildConstructionBaseInfo(List<int> lstConstructionCode, ref List<ConstructionBaseInfo> datas)
+        {
+            var sbDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事基本情報取得クラス領域
+                var wrk = new List<ConstructionBaseInfo>();
+
+                // 工事基本情報取得SQL
+                string strSQL = " WHERE ConstructionCode IN ";
+                strSQL += "( ";
+                foreach (int code in lstConstructionCode)
+                {
+                    strSQL += code.ToString();
+                    strSQL += (lstConstructionCode.IndexOf(code) != lstConstructionCode.Count - 1) ? ", " : string.Empty;
+                }
+                strSQL += " ) ";
+                strSQL += "ORDER BY ConstructionCode ";
+
+                // 工事基本情報取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                datas = wrk;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事基本情報明細
+        /// <summary>
+        /// 工事基本情報明細を工事基本情報明細テーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionBaseInfoDetail(int constructionCode, ref Dictionary<int,string> datas)
+        {
+            var sbDB = new IOConstructionBaseInfoDetail();
+            try
+            {
+                // 工事基本情報明細取得クラス領域
+                var wrk = new List<ConstructionBaseInfoDetail>();
+
+                // 工事基本情報明細取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事基本情報明細取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var detail in wrk)
+                {
+                    datas.Add(detail.DetailNo, detail.DetailString);
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 増減工事用工事基本情報明細取得
+        /// <summary>
+        /// 本工事の工事番号をキーに増減工事分のすべての工事基本明細情報を取得する
+        /// </summary>
+        /// <param name="constructionCode">本工事番号</param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetChildConstructionBaseInfoDetail(List<int> lstConstructionCode, ref Dictionary<int,Dictionary<int,string>> datas)
+        {
+            var sbDB = new IOConstructionBaseInfoDetail();
+            try
+            {
+                // 工事基本情報明細取得クラス領域
+                var wrk = new List<ConstructionBaseInfoDetail>();
+
+                // 工事基本情報明細取得SQL
+                string strSQL = " WHERE ConstructionCode IN ";
+                strSQL += "( ";
+                foreach (int code in lstConstructionCode)
+                {
+                    strSQL += code.ToString();
+                    strSQL += (lstConstructionCode.IndexOf(code) != lstConstructionCode.Count - 1) ? ", " : string.Empty;
+                }
+                strSQL += " ) ";
+
+                // 工事基本情報明細取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var detail in wrk)
+                {
+                    if (!datas.ContainsKey(detail.ConstructionCode))
+                    {
+                        datas[detail.ConstructionCode] = new Dictionary<int, string>();
+                    }
+                    datas[detail.ConstructionCode][detail.DetailNo] = detail.DetailString;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事増減情報
+        /// <summary>
+        /// 工事増減情報を工事増減情報テーブルから本工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="lstChldConstructionCode"></param>
+        /// <returns></returns>
+        private bool GetConstructionLink(ref List<int> lstChldConstructionCode)
+        {
+            var sbDB = new IOConstructionLink();
+            try
+            {
+                // 工事増減情報取得クラス領域
+                var wrk = new List<ConstructionLink>();
+
+                // 工事増減情報取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(m_ConstructionCode);
+
+                // ソート条件を設定
+                strSQL += " ORDER BY FLUCTUATIONCODE";
+
+                // 工事増減情報取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 工事増減情報をリストにセット
+                lstChldConstructionCode.Clear();
+                foreach (var detail in wrk)
+                {
+                    lstChldConstructionCode.Add(detail.FluctuationCode);
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 工事詳細台帳データ
+        /// <summary>
+        /// 工事詳細台帳データを工事詳細台帳データテーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetConstructionLedger(int constructionCode, ref ConstructionLedger data)
+        {
+            var sbDB = new IOConstructionLedger();
+            try
+            {
+                // 工事詳細台帳データ取得クラス領域
+                var wrk = new ConstructionLedger();
+
+                // 工事詳細台帳データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 工事詳細台帳データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                data = wrk;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+
+        }
+        #endregion
+
+        #region 増減工事用工事詳細台帳データ
+        /// <summary>
+        /// 本工事の工事番号をキーに増減工事分のすべての工事詳細台帳データを取得する
+        /// </summary>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetChildConstructionLedger(List<int> lstConstructionCode, ref Dictionary<int,ConstructionLedger> datas)
+        {
+            var sbDB = new IOConstructionLedger();
+            try
+            {
+                // 工事詳細台帳データ取得クラス領域
+                var wrk = new List<ConstructionLedger>();
+
+                // 工事詳細台帳データ取得SQL
+                string strSQL = " WHERE ConstructionCode IN ";
+                strSQL += "( ";
+                foreach (int code in lstConstructionCode)
+                {
+                    strSQL += code.ToString();
+                    strSQL += (lstConstructionCode.IndexOf(code) != lstConstructionCode.Count - 1) ? ", " : string.Empty;
+                }
+                strSQL += " ) ";
+
+                // 工事詳細台帳データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var record in wrk)
+                {
+                    datas[record.ConstructionCode] = record;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+
+        }
+        #endregion
+
+        #region 請求データ
+        /// <summary>
+        /// 請求データを請求データテーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="data"></param>
+        /// <returns>true：成功 false：失敗</returns>
+        private bool GetRequestData(ref RequestData data)
+        {
+            var sbDB = new IORequestData();
+            try
+            {
+                // 請求データ取得クラス領域
+                var wrk = new List<RequestData>();
+
+                // 請求データ取得SQL
+                string strSQL = sbDB.CreateSubkeyString(m_ConstructionCode);
+
+                // 請求データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                if (wrk.Count != 1) return false;
+
+                data = wrk[0];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 請求データ (from 工事基本情報)
+        /// <summary>
+        /// 請求データに登録する情報を工事基本情報から取得
+        /// </summary>
+        /// <param name="data"></param>
+        private bool GetRequestDataFromConstructionBase(ref RequestData data)
+        {
+            var sbDB = new IOConstructionBaseInfo();
+
+            try
+            {
+                // 工事基本情報取得クラス領域
+                List<ConstructionBaseInfo> wrk = new List<ConstructionBaseInfo>();
+
+                // 工事基本情報取得SQL
+                string strSQL = string.Format(" where ConstructionCode = {0} ", data.RequestNo);
+
+                // 読み込み
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach(ConstructionBaseInfo info in wrk)
+                {
+                    data.OrderersDivision = info.OrderersDivision;
+                    data.OrderersCode = info.OrderersCode;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+            return true;
+        }
+        #endregion
+
+        #region 請求合計データ
+        /// <summary>
+        /// 請求合計データを請求合計データテーブルから請求Noをキーに取得する関数
+        /// </summary>
+        /// <param name="RequestNo">請求No</param>
+        /// <param name="data"></param>
+        /// <returns>true：成功 false：失敗</returns>
+        private bool GetRequestTotalDatas(int RequestNo, ref List<RequestTotalData> data)
+        {
+            var sbDB = new IORequestTotalData();
+            try
+            {
+                // 請求合計データ取得クラス領域
+                var wrk = new List<RequestTotalData>();
+
+                // 請求合計データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(RequestNo);
+
+                // ソート条件を追加
+                strSQL += " ORDER BY REQUESTNO, ORDERNO";
+
+                // 請求合計データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                foreach (var record in wrk)
+                {
+                    m_DicReqTotalRec[record] = true;
+                }
+                data = wrk;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+
+        }
+        #endregion
+
+        #region 請求明細データ
+        /// <summary>
+        /// 請求明細データを請求明細データテーブルから請求Noをキーに取得する関数
+        /// </summary>
+        /// <param name="RequestNo"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetRequestDataDetails(int RequestNo, ref Dictionary<int,Dictionary<int,RequestDataDetail>> datas)
+        {
+            var sbDB = new IORequestDataDetail();
+            try
+            {
+                // 請求明細データ取得クラス領域
+                var wrk = new List<RequestDataDetail>();
+
+                // 請求明細データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(RequestNo);
+
+                // ソート条件を追加
+                strSQL += " ORDER BY REQUESTNO, ORDERNO, CONSTRUCTIONCODE";
+
+                // 請求明細データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 取得したデータをハッシュテーブルにセット
+                foreach (var detail in wrk)
+                {
+                    if (!datas.ContainsKey(detail.ConstructionCode))
+                    {
+                        datas[detail.ConstructionCode] = new Dictionary<int, RequestDataDetail>();
+                    }
+                    datas[detail.ConstructionCode][detail.OrderNo] = detail;
+                    m_DicReqDetailRec[detail] = true;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+
+        }
+        #endregion
+
+        #region 承認データ
+        /// <summary>
+        /// 承認データを承認データテーブルから工事番号をキーに取得する関数
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="htProcessApproval"></param>
+        /// <returns></returns>
+        private bool GetProcessApproval(int constructionCode, ref Dictionary<int,List<ProcessApproval>> datas)
+        {
+            var sbDB = new IOProcessApproval();
+            try
+            {
+                // 承認データ取得クラス領域
+                var wrk = new List<ProcessApproval>();
+
+                // 承認データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode, 5);
+
+                // 承認データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 取得したデータをハッシュテーブルにセット
+                foreach (var detail in wrk)
+                {
+                    if (!datas.ContainsKey(detail.OrderNo))
+                    {
+                        datas[detail.OrderNo] = new List<ProcessApproval>();
+                    }
+                    datas[detail.OrderNo].Add(detail);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 承認経路データ
+        /// <summary>
+        /// 承認経路データを承認経路マスタから取得する
+        /// </summary>
+        /// <param name="personCode"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetApprovalMaster(int personCode, ref Dictionary<int,ApprovalMaster> datas)
+        {
+            var sbDB = new IOMApproval();
+            try
+            {
+                // 承認経路データ取得クラス領域
+                var wrk = new List<ApprovalMaster>();
+
+                // 承認経路データ取得SQL
+                string strSQL = " WHERE APPROVALCODE = 5";
+                strSQL += " AND DEPARTMENTCODE = ( SELECT DEPARTMENTCODE FROM PERSONINCHARGEMASTER WHERE PERSONCODE = ";
+                strSQL += string.Format("{0})", personCode);
+
+                // 承認経路データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                datas.Clear();
+
+                foreach (var record in wrk)
+                {
+                    datas[record.ApprovalPerson] = record;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 入金データ
+        /// <summary>
+        /// 入金データを入金データテーブルから主キーで検索して取得する関数
+        /// </summary>
+        /// <param name="OrderesDivision"></param>
+        /// <param name="OrderesCode"></param>
+        /// <param name="TargetDate"></param>
+        /// <param name="SeqNo"></param>
+        /// <param name="data"></param>
+        /// <returns></returns>
+        private bool GetDepositData(int OrderesDivision, int OrderesCode, string TargetDate, int SeqNo, ref DepositData data)
+        {
+            var sbDB = new IODepositData();
+            try
+            {
+                // 入金データ取得クラス領域
+                var wrk = new List<DepositData>();
+
+                // 入金データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(OrderesDivision, OrderesCode, TargetDate, SeqNo);
+
+                // 入金データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                if (wrk.Count != 1) return false;
+
+                data = wrk[0];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 入金明細データ
+        /// <summary>
+        /// 入金明細データを入金明細データテーブルから請求Noをキーに取得する関数
+        /// </summary>
+        /// <param name="requestNo"></param>
+        /// <param name="htDepositDataDetail"></param>
+        /// <returns></returns>
+        private bool GetDepositDataDetail(int requestNo, ref Dictionary<int,DepositDataDetail> datas)
+        {
+            var sbDB = new IODepositDataDetail();
+            try
+            {
+                // 入金明細データ取得クラス領域
+                var wrk = new List<DepositDataDetail>();
+
+                // 入金明細データ取得SQL
+                string strSQL = sbDB.CreateSubkeyString(requestNo);
+
+                // 入金明細データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 入金明細データをハッシュテーブルにセット
+                foreach (var detail in wrk)
+                {
+                    datas[detail.OrderNo] = detail;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #region 案件進捗日付データ
+        /// <summary>
+        /// 案件進捗日付データを取得する
+        /// </summary>
+        /// <param name="constructionCode"></param>
+        /// <param name="datas"></param>
+        /// <returns></returns>
+        private bool GetConstructionProgressDate(int constructionCode, ref Dictionary<int, ConstructionProgressDate> datas)
+        {
+            var sbDB = new IOConstructionProgressDate();
+            try
+            {
+                // 案件進捗日付データ取得クラス領域
+                var wrk = new List<ConstructionProgressDate>();
+
+                // 案件進捗日付データ取得SQL
+                string strSQL = sbDB.CreatePrimarykeyString(constructionCode);
+
+                // 案件進捗日付データ取得
+                if (!sbDB.SelectAction(strSQL, ref wrk)) return false;
+
+                // 案件進捗日付データをディクショナリにセット
+                foreach (var record in wrk)
+                {
+                    datas[record.ConstructionStatusFlg] = record;
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                sbDB.close();
+                sbDB = null;
+            }
+
+            return true;
+        }
+        #endregion
+
+        #endregion
+    }
+}
